SpellReduxSettings = {}
NEW_SPELL = "<New>"

function SpellReduxSettings:OnLoad(frame)
	frame.name = "SpellRedux";
	
	frame.tarDebuffPanel = CreateFrame("Frame", "tarDebuffPanel", frame, "SpellReduxSettingsModel");
	frame.tarDebuffPanel.name = "Target Debuffs"
	frame.tarDebuffPanel.parent = frame.name;
	SpellReduxSettings:configureDebuffFrame(frame.tarDebuffPanel);
	
	frame.selfBuffPanel = CreateFrame("Frame", "selfBuffPanel", frame, "SpellReduxSettingsModel");
	frame.selfBuffPanel.name = "Player Buffs"
	frame.selfBuffPanel.parent = frame.name;
	SpellReduxSettings:configureBuffFrame(frame.selfBuffPanel);
	
	InterfaceOptions_AddCategory(frame);
	InterfaceOptions_AddCategory(frame.tarDebuffPanel);
	InterfaceOptions_AddCategory(frame.selfBuffPanel);
end

-- ================================== BUFFS ===============================
function SpellReduxSettings:configureBuffFrame(frame)

	frame.onSelectSpell = SpellReduxSettings_onSelectSpell;
	frame.spellList = SpellReduxSettings_getPBuffSpells;
	frame.clearBoxes = clearPBBoxes;
	_G[frame:GetName().."Title"]:SetText("Player Buffs");	

	local cmbss = _G[frame:GetName().."SpellSelect"];
	UIDropDownMenu_Initialize(cmbss, SpellReduxSettings_onOpenSpells);
	UIDropDownMenu_SetWidth(cmbss, 125, 0);
	
	local cmbsts = _G[frame:GetName().."SpellTypeSelect"];
	UIDropDownMenu_Initialize(cmbsts, SpellReduxSettings_onOpenBuffSpellType);
	UIDropDownMenu_SetWidth(cmbsts, 125, 0);

	_G[frame:GetName().."Save"]:SetScript("OnClick", SpellReduxSettings_saveSpell); 
	_G[frame:GetName().."Delete"]:SetScript("OnClick", SpellReduxSettings_deleteSpell); 
	
	clearPBBoxes(frame);
end

function clearPBBoxes(frame)
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelect"], NEW_SPELL, false);
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelect"], NEW_SPELL);
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellTypeSelect"], BUFF, false); 
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellTypeSelect"], BUFF);
	_G[frame:GetName().."AppliedByEdit"]:SetText("");
	_G[frame:GetName().."AppliedBy"]:Show(); 
	_G[frame:GetName().."AppliedByEdit"]:Show();
	_G[frame:GetName().."TicksEvery"]:Hide();
	_G[frame:GetName().."TicksEveryEdit"]:SetText("");
	_G[frame:GetName().."TicksEveryEdit"]:Hide();
	_G[frame:GetName().."TicksEverySec"]:Hide();
	_G[frame:GetName().."SpellNameEdit"]:SetText("");
	_G[frame:GetName().."SpellNameEdit"]:Enable();
end

function SpellReduxSettings_onOpenBuffSpellType(frame, level, menuList)
	local info      = {};
	info.text       = BUFF; --localize this
	info.func       = SpellReduxSettings_onSelectTypeBuff;
	info.arg1		= frame;
	info.arg2		= BUFF;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == BUFF;
	UIDropDownMenu_AddButton(info);
	
	-- hots 
end

function SpellReduxSettings_onSelectTypeBuff(self, arg1, arg2, checked)
	UIDropDownMenu_SetSelectedName(arg1, arg2, false);
end

function SpellReduxSettings_getPBuffSpells()
	return selfBuffSpells;
end
-- ================================== BUFFS ===============================

-- ================================== DEBUFFS ===============================
function SpellReduxSettings:configureDebuffFrame(frame)

	frame.clearBoxes = clearTDBoxes;
	frame.onSelectSpell = SpellReduxSettings_onSelectSpell;
	frame.spellList = SpellReduxSettings_getTDebuffSpells;

	_G[frame:GetName().."Title"]:SetText("Target Debuffs");	

	local cmbss = _G[frame:GetName().."SpellSelect"];
	UIDropDownMenu_Initialize(cmbss, SpellReduxSettings_onOpenSpells);
	UIDropDownMenu_SetWidth(cmbss, 125, 0);
	
	local cmbsts = _G[frame:GetName().."SpellTypeSelect"];
	UIDropDownMenu_Initialize(cmbsts, SpellReduxSettings_onOpenDebuffSpellType);
	UIDropDownMenu_SetWidth(cmbsts, 125, 0);

	_G[frame:GetName().."Save"]:SetScript("OnClick", SpellReduxSettings_saveSpell); 
	_G[frame:GetName().."Delete"]:SetScript("OnClick", SpellReduxSettings_deleteSpell); 
	
	
	clearTDBoxes(frame);
end

function SpellReduxSettings_getTDebuffSpells()
	return targetDebuffSpells;
end

function SpellReduxSettings_onOpenDebuffSpellType(frame, level, menuList)
	local info      = {};
	info.text       = DOT; --localize this
	info.func       = SpellReduxSettings_onSelectTypeDebuff;
	info.arg1		= frame;
	info.arg2		= DOT;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == DOT;
	UIDropDownMenu_AddButton(info);
	
	info.text       = DEBUFF; --localize this
	info.func       = SpellReduxSettings_onSelectTypeDebuff;
	info.arg1		= frame;
	info.arg2		= DEBUFF;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == DEBUFF;
	UIDropDownMenu_AddButton(info);
end

function SpellReduxSettings_onSelectTypeDebuff(self, arg1, arg2, checked)
	local frame = arg1:GetParent();
	UIDropDownMenu_SetSelectedName(arg1, arg2, false);
	if (arg2 == DOT) then
		_G[frame:GetName().."TicksEvery"]:Show();
		_G[frame:GetName().."TicksEveryEdit"]:Show();
		_G[frame:GetName().."TicksEverySec"]:Show();
		_G[frame:GetName().."AppliedBy"]:Hide(); 		
		_G[frame:GetName().."AppliedByEdit"]:Hide(); 
	elseif (arg2 == DEBUFF) then
		_G[frame:GetName().."TicksEvery"]:Hide();
		_G[frame:GetName().."TicksEveryEdit"]:Hide();
		_G[frame:GetName().."TicksEverySec"]:Hide()
		_G[frame:GetName().."AppliedBy"]:Show(); 
		_G[frame:GetName().."AppliedByEdit"]:Show(); 
	end
end

function clearTDBoxes(frame)
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelect"], NEW_SPELL, false);
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelect"], NEW_SPELL);
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellTypeSelect"], DOT, false); 
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellTypeSelect"], DOT);
	_G[frame:GetName().."AppliedByEdit"]:SetText("");
	_G[frame:GetName().."AppliedBy"]:Hide(); 
	_G[frame:GetName().."AppliedByEdit"]:Hide();
	_G[frame:GetName().."TicksEvery"]:Show();
	_G[frame:GetName().."TicksEveryEdit"]:SetText("");
	_G[frame:GetName().."TicksEveryEdit"]:Show();
	_G[frame:GetName().."TicksEverySec"]:Show();
	_G[frame:GetName().."SpellNameEdit"]:SetText("");
	_G[frame:GetName().."SpellNameEdit"]:Enable();
end

-- ================================== DEBUFFS ===============================

function SpellReduxSettings_saveSpell(self, button, down)
	local spell = {};
	spell.spell_name = _G[self:GetParent():GetName().."SpellNameEdit"]:GetText();
	if spell.spell_name == nil or spell.spell_name == "" then
		return;
	end
	
	spell.spell_type = UIDropDownMenu_GetText(_G[self:GetParent():GetName().."SpellTypeSelect"]);
	if spell.spell_type == DOT then
		spell.tick_frequency = _G[self:GetParent():GetName().."TicksEveryEdit"]:GetText();
		if spell.tick_frequency == nil or spell.tick_frequency == "" then
			spell.tick_frequency = 0;
		end
	elseif spell.spell_type == DEBUFF or spell.spell_type == BUFF then
		local appliedby = _G[self:GetParent():GetName().."AppliedByEdit"]:GetText();
		if appliedby then spell.applied_by = appliedby end;		
	end
	
	local spellList = 
	SpellRedux:NewSpell(spell, self:GetParent().spellList());
	
	self:GetParent().clearBoxes(self:GetParent())
end

function SpellReduxSettings_deleteSpell(self, button, down)
	local spellName = _G[self:GetParent():GetName().."SpellNameEdit"]:GetText();
	if spellName ~= nil and spellName ~= '' then	
		SpellRedux:DeleteSpell(spellName, self:GetParent().spellList())	
		self:GetParent().clearBoxes(self:GetParent());
	end
end

function SpellReduxSettings_onOpenSpells(frame, level, menuList)
	local panel = frame:GetParent();
	local spellList = panel.spellList();
	local info      = {};
	info.text       = NEW_SPELL; --localize this
	info.func       = panel.onSelectSpell;
	info.arg1		= frame;
	info.arg2		= NEW_SPELL;
	--info.isNotRadio = true;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == NEW_SPELL;
	UIDropDownMenu_AddButton(info)
	for i, spell in ipairs(spellList) do
		info.text       = spell.spell_name;
		info.arg2		= spell.spell_name;
		info.checked	= UIDropDownMenu_GetSelectedName(frame) == info.text ;
		local name, rank, icon = GetSpellInfo(spell.spell_name);
		info.icon		= icon;
		UIDropDownMenu_AddButton(info);
	end
end

function SpellReduxSettings_onSelectSpell(self, arg1, arg2, checked)
	local frame = arg1:GetParent();
	UIDropDownMenu_SetSelectedName(arg1, arg2, false) 

	if (arg2 == NEW_SPELL) then
		frame.clearBoxes(frame);
	else
		local spellList = frame.spellList();
		local spell = GetSpell(spellList,arg2);
		_G[frame:GetName().."SpellNameEdit"]:SetText(arg2);		
		UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellTypeSelect"], spell.spell_type,false);
		UIDropDownMenu_SetText(_G[frame:GetName().."SpellTypeSelect"], spell.spell_type);
		if spell.spell_type == DOT then
			_G[frame:GetName().."TicksEvery"]:Show();
			_G[frame:GetName().."TicksEveryEdit"]:SetText(spell.tick_frequency);
			_G[frame:GetName().."TicksEveryEdit"]:Show();
			_G[frame:GetName().."TicksEverySec"]:Show();
			_G[frame:GetName().."AppliedBy"]:Hide(); 
			_G[frame:GetName().."AppliedByEdit"]:Hide(); 
		elseif spell.spell_type == DEBUFF then
			_G[frame:GetName().."TicksEvery"]:Hide();
			_G[frame:GetName().."TicksEveryEdit"]:Hide();
			_G[frame:GetName().."TicksEverySec"]:Hide()
			_G[frame:GetName().."AppliedBy"]:Show(); 
			if spell.applied_by ~= nil then 
				_G[frame:GetName().."AppliedByEdit"]:SetText(spell.applied_by);
			end 
			_G[frame:GetName().."AppliedByEdit"]:Show(); 
		elseif spell.spell_type == BUFF then
			if spell.applied_by ~= nil then 
				_G[frame:GetName().."AppliedByEdit"]:SetText(spell.applied_by);
			end 
		end 
		_G[frame:GetName().."SpellNameEdit"]:Disable();
	end
end
