SpellShader = {}

RESPONSE_TIME = 300 -- milliseconds, response time based on how fast we percieve (padded)
BUFFER_TIME = 1000 -- milliseconds, extra time added for applying less important (de)buffs 

function SpellShader:new(spell)
	local object = { spell = spell, doShade = nil }
	local funcname = string.gsub(spell.name, " ", "_");

	setmetatable (object, { __index = SpellShader } )
	
	if self[funcname] == nil then
		object.doShade = self["generic"];
	else
		object.doShade = self[funcname];
	end
	return object
end

--function SpellShader:Bane_of_Doom()
		
--end

function SpellShader:generic()
	local cast_threshold = 0;
	if self.spell.props.spell_type == DOT then
		local down, up, lagHome, lagWorld = GetNetStats();
		cast_threshold = self.spell.props.tickTime + self.spell.props.castTime + lagWorld + RESPONSE_TIME;	
		if self.spell.timeleft <= cast_threshold - self.spell.props.tickTime - RESPONSE_TIME then
			--dot will drop off			
			self.spell.texture:SetVertexColor(1,0,0);
		elseif self.spell.timeleft <= cast_threshold then			
			--optimum time to cast gogogo
			self.spell.texture:SetDesaturated(nil);
			self.spell.texture:SetAlpha(1);
		else
			self.spell.texture:SetVertexColor(1,1,1);
			self.spell.texture:SetAlpha(SPELL_OPACITY);
			self.spell.texture:SetDesaturated(1);
		end
	elseif self.spell.props.spell_type == DEBUFF or self.spell.props.spell_type == BUFF then
		if self.spell.props.castTime then
			local down, up, lagHome, lagWorld = GetNetStats();
			cast_threshold = self.spell.props.castTime + lagWorld + RESPONSE_TIME + BUFFER_TIME;	
			if self.spell.timeleft <= cast_threshold then			
				--optimum time to cast gogogo
				self.spell.texture:SetDesaturated(nil);
				self.spell.texture:SetAlpha(1);
			else
				self.spell.texture:SetVertexColor(1,1,1);
				self.spell.texture:SetAlpha(SPELL_OPACITY);
				self.spell.texture:SetDesaturated(1);
			end
		end
	end
end

